/**********************************
 * blog.iriscores.com 2016/2022
 * Author: vojta.ters@iriscores.com
 **********************************/

// ------------------------------
// -------- Cuda Includes -------
#include <cuda_runtime.h>
#include <device_launch_parameters.h>
#include <cufft.h>
#include <math_constants.h>


__global__ void Kern_DigitReversal(cufftComplex* InData, cufftComplex* OutData,int *Indexes, int Nx, int Base, int NumDigits);
__global__ void Kern_Compute_Twiddles(cufftComplex* Twiddles, int N);


__global__ void Kern_R2_Global(cufftComplex* Data, const cufftComplex* Twiddles, int Distance, int Stage, int Steps, int Nx, bool TwiddlePrecalculate);
__global__ void Kern_R2_Shared(cufftComplex* Data, const cufftComplex* Twiddles, int Distance, int Stage, int Steps, int Nx, bool TwiddlePrecalculate);

__global__ void Kern_R4_Global(cufftComplex* Data, const cufftComplex* Twiddles, int Distance, int Stage, int Steps, int Nx, bool TwiddlePrecalculate);
__global__ void Kern_R4_Shared(cufftComplex* Data, const cufftComplex* Twiddles, int Distance, int Stage, int Steps, int Nx, bool TwiddlePrecalculate);

__global__ void Kern_R8_Global(cufftComplex* Data, const cufftComplex* Twiddles, int Distance, int Stage, int Steps, int Nx, bool TwiddlePrecalculate);
__global__ void Kern_R8_Shared(cufftComplex* Data, const cufftComplex* Twiddles, int Distance, int Stage, int Steps, int Nx, bool TwiddlePrecalculate);