close all;
clear all;
clc;

%%%%%%%%%%%%%%%%%%%%%%%%%%
% get Display Resolution %
Displ = groot();
ScW = Displ.ScreenSize(3);
ScH = Displ.ScreenSize(4);
FiW = 1440;
FiH = 720;
Cls = perms([0,102,204])./255;

%%%%%%%%%%%%%%%%%
% Configuration %
FFT_Length = 16;
Radix      = 4;
NumDigits = log(FFT_Length)/log(Radix);

Indexes    = zeros(1,FFT_Length);
RevIndexes = zeros(1,FFT_Length);


for i = 1:FFT_Length
    
    Index = i - 1;
    %%%%%%%%%%%%%%%%%%%%%%%%%%
    % Convert to Base Digits %
    Bases = Dec2Base(Index,Radix,NumDigits);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Reverse The Digit Order %
    BaseRev = DigitReversal(Bases,NumDigits);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Convert Back to New Index %
    DigitRevIndex = Base2Dec(BaseRev,Radix,NumDigits);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    % Save Original And Reversed Index %
    Indexes(i)    = Index;
    RevIndexes(i) = DigitRevIndex;
    
    STR1 = sprintf('%3d',Index);
    STR2 = sprintf('%3d',DigitRevIndex);
    disp(['Index',STR1,' || Digits: [',num2str(Bases),'] || Reversed: [',num2str(BaseRev), '] || RevIndex: ',STR2]);
end

%%%%%%%%%%%%%%%%%%%%%
% Compute Reference %
RefIndexes = digitrevorder(Indexes,Radix);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Display Result Comparison %
S0 = sprintf('%3d',Indexes);
S1 = sprintf('%3d',RevIndexes);
S2 = sprintf('%3d',RefIndexes);
disp(['Indexes:   ',S0]);
disp(['Reversed:  ',S1]);
disp(['Reference: ',S2]);